class ContactsProjectsController < ApplicationController
  unloadable
  
  before_filter :find_project_by_project_id, :authorize 
  before_filter :find_contact
  before_filter :check_count, :find_related_project, :only => :delete

  helper :contacts
  
  def add
    @show_form = "true"          
    # find_contact
    if params[:related_project_id] then   
      find_related_project 
      @contact.projects << @related_project
      @contact.save if request.post?   
    end
    respond_to do |format|
      format.html { redirect_to :back }  
      format.js
    end
  rescue ::ActionController::RedirectBackError
    render :text => 'Project added.', :layout => true
  end

  def delete  
    @contact.projects.delete(@related_project) if request.delete?
    respond_to do |format|
      format.html { redirect_to :back }
      format.js {render :action => "add"}
    end    
  end
  
  private

  def find_related_project
    @related_project = Project.find(params[:related_project_id])
    raise Unauthorized unless User.current.allowed_to?(:edit_contacts, @related_project)
  rescue ActiveRecord::RecordNotFound
    render_404  
  end
  
  def check_count
    deny_access if @contact.projects.size <= 1 
  end
  
  def find_contact 
    @contact = Contact.find(params[:contact_id]) 
  rescue ActiveRecord::RecordNotFound
    render_404
  end
  
end
